#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/iocs.h>
#include "sel.h"

#define SIZE (25)			/* y̕\TCY */
#define ROLLSIZE (SIZE)		/* ROLLUP/DOWN ̃XLbvTCY */

static void listup_char( int n )
{
	int i;

	_iocs_b_color(1);
	for ( i = 0; i < SIZE; i++ ) {
		if ( n + i >= max ) break;
		_iocs_b_locate(2,3+i);
		printf("%-14s %-14s %3d%% ",p[n+i].name,p[n+i].stage,p[n+i].appear);
	}
}

static void activate_char( int c , int margin )
{
	_iocs_b_color(9);
	_iocs_b_locate(2,3+c-margin);
	printf("%-14s %-14s %3d%% ",p[c].name,p[c].stage,p[c].appear);
}

static void inactivate_char( int c , int margin )
{
	_iocs_b_color(1);
	_iocs_b_locate(2,3+c-margin);
	printf("%-14s %-14s %3d%% ",p[c].name,p[c].stage,p[c].appear);
}

static void init_window()
{
	prints(15,0,"\x1b[37mRamdom character selector\x1b[m sel.x version "VERSION" for SFXVI 1995 by appyo\n");

	draw_window( 0, 2,19,28);
	draw_window(24, 3,40,12);
	draw_window(20,14,47,26);

	prints( 2,2,"LN^");
	prints(16,2,"Xe[W");
	prints(31,2,"o");
	prints(51,3,"ڑI");

	prints(43,14,"L[");
	prints(42,15,"[] / C-n / n         ...  J[\ړ");
	prints(42,16,"[] / C-p / p         ...  J[\ړ");
	prints(42,17,"[ROLLUP]               ...  y[W");
	prints(42,18,"[ROLLDOWN]             ...  Oy[W");
	prints(42,19,"[RET] / [SPACE] / C-m  ...  LI");
	prints(42,20,"[] / C-f             ...  ");
	prints(42,21,"[] / C-b             ...  O");
	prints(42,22," a                     ...  oɃ\[g\");
	prints(42,23," s                     ...  OɃ\[g\");
	prints(42,24," t                     ...  timestampɃ\[g\");
	prints(42,25,"[ESC] / [UNDO] / q     ...  ZN^I");
}

static int stnametonum( char *name )
{
	int i;

	for ( i = 0; i < smax; i++ )
		if ( strcmp(name,s[i].name) == 0 ) return i;

	return 0;
}

static void putcel( CHAR *m , int mode )
{
	char trash[64];

	_iocs_b_color( mode == 0 ? 11 : 3 );
	sprintf(trash,"%3d%%",m->appear);
	prints(64,7,trash);

	_iocs_b_color( mode == 1 ? 11 : 3 );
	sprintf(trash,"%-14s",m->stage);
	prints(64,9,trash);
}

/* ʍڑI */
static void change_value( int c , int margin )
{
	CHAR *m = &p[c];
	char trash[64],orig[24];
	int k,n,mode=0,o;

	_iocs_b_color(3);
	sprintf(trash,"LN^F%-14s",m->name);
	prints(52,5,trash);
	prints(52,7,"    oF");
	prints(52,9,"  Xe[WF");
	putcel(m,mode);

	strcpy(orig,m->name);
	o = m->appear;

	do {
		k = get_keycode();
		if ( k == UP || k == CTRL_P || k == 'p' || k == 'P' ) {
			mode = 0;
			putcel(m,mode);
			activate_char(c,margin);
		}
		if ( k == DOWN || k == CTRL_N || k == 'n' || k == 'N' ) {
			mode = 1;
			putcel(m,mode);
			activate_char(c,margin);
		}
		if ( k == LEFT || k == 2 ) {
			switch ( mode ) {
			case 0:
				if ( m->appear > 0 ) {
					m->appear -= 10;
					putcel(m,mode);
					activate_char(c,margin);
				}
				break;
			case 1:
				n = stnametonum(m->stage);
				if ( n > 0 ) {
					n--;
					strcpy(m->stage,s[n].name);
					putcel(m,mode);
					activate_char(c,margin);
				}
				break;
			}
		}
		if ( k == RIGHT || k == 6 ) {
			switch ( mode ) {
			case 0:
				if ( m->appear < 100 ) {
					m->appear += 10;
					putcel(m,mode);
					activate_char(c,margin);
				}
				break;
			case 1:
				n = stnametonum(m->stage);
				if ( n < smax - 1 ) {
					n++;
					strcpy(m->stage,s[n].name);
					putcel(m,mode);
					activate_char(c,margin);
				}
				break;
			}
		}
		if ( k == ESC || k == UNDO || k == 7 || k == 'q' || k == 'Q' ) {
			strcpy(m->name,orig);
			m->appear = o;
			break;
		}
	} while ( k != RET && k != SPC );

	_iocs_b_color(3);
	prints(52,5,"                          ");
	prints(52,7,"                          ");
	prints(52,9,"                          ");
}

/* ZN^C */
void select()
{
	int c=0;			/* JgCHAR No. */
	int margin=0;		/* ʏňԏɂCHAR No. */
	int k;

	appear_sort();
	init_window();
	listup_char(margin);

	activate_char(c,margin);
	do {
		k = get_keycode();
		if ( k == DOWN || k == CTRL_N || k == 'n' || k == 'N' ) {
			if ( c < max-1 ) {
				inactivate_char(c,margin);
				c++;
				if ( c - margin > 21 && margin + SIZE < max ) {
					scroll_up();
					margin++;
					inactivate_char(margin+SIZE-1,margin);
				}
				activate_char(c,margin);
			}
		}
		if ( k == UP || k == CTRL_P || k == 'p' || k == 'P' ) {
			if ( c > 0 ) {
				inactivate_char(c,margin);
				c--;
				if ( c - margin < 3 && margin > 0 ) {
					scroll_down();
					margin--;
					inactivate_char(margin,margin);
				}
				activate_char(c,margin);
			}
		}
		if ( k == ROLLUP ) {
			inactivate_char(c,margin);
			c += ROLLSIZE;
			margin += ROLLSIZE;
			if ( margin + SIZE >= max ) {
				margin = max - SIZE;
				c = max-1;
			}
			listup_char(margin);
			activate_char(c,margin);
		}
		if ( k == ROLLDOWN ) {
			inactivate_char(c,margin);
			c -= ROLLSIZE;
			margin -= ROLLSIZE;
			if ( margin < 0 ) {
				margin = 0;
				c = 0;
			}
			listup_char(margin);
			activate_char(c,margin);
		}
		if ( k == 's' || k == 'S' ) {
			inactivate_char(c,margin);
			name_sort();
			margin = c = 0;
			listup_char(margin);
			activate_char(c,margin);
		}
		if ( k == 'a' || k == 'A' ) {
			inactivate_char(c,margin);
			appear_sort();
			margin = c = 0;
			listup_char(margin);
			activate_char(c,margin);
		}
		if ( k == 't' || k == 'T' ) {
			inactivate_char(c,margin);
			time_sort();
			margin = c = 0;
			listup_char(margin);
			activate_char(c,margin);
		}
		if ( k == RET || k == SPC ) {
			change_value(c,margin);
			activate_char(c,margin);
		}
	} while ( k != ESC && k != UNDO && k != 'q' && k != 'Q' );
}
